/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// 日付関連ユーティリティクラス。
// 
//
//	変更履歴
//	2004/01/08 新規作成	T.Nishiki 
//
package jp.co.ntt.lms.xms.common.util;

import java.util.Calendar;
import java.util.Date;

/**
 * 日付関連ユーティリティクラス。
 * @author T.Nishiki
 */
public final class DateUtil {

	/**
	 * 指定した年月日が日付として妥当か判定する。<br>
	 * 
	 * @param year 年数。
	 * @param month 月数。
	 * @param day 日数。
	 * @param hour 時数。
	 * @param minute 分数。
	 * @param second 秒数。
	 * @return 指定した日付が正当な値であれば、対応するDateオブジェクト。
	 *          不正な値が含まれていれば、nullを戻す。
	 */
	public static Date isDate(int year, int month, int day) {
		Date date = null;
		date = isDate(year, month, day, 0, 0, 0);
		return date;
	}

	/**
	 * 指定した年月日時分秒が日時として妥当か判定する。<br>
	 * 
	 * @param year 年数。
	 * @param month 月数(1-12)。
	 * @param day 日数（1-31、ただし年月によっては最大値は変化する）。
	 * @param hour 時数(0-24)。
	 * @param minute 分数(0-59)。
	 * @param second 秒数(0-59)。
	 * @return 指定した日時が正当な値であれば、対応するDateオブジェクト。
	 *          不正な値が含まれていれば、nullを戻す。
	 */
	public static Date isDate(
			int year, int month, int day,
			int hour, int minute, int second) {
		Date date = null;
		Calendar calendar = null;
		
		calendar = Calendar.getInstance();
		calendar.clear();
		calendar.set(year, month-1, day, hour, minute, second);
		
		// 生成後の年月日時分秒の値を取得
		int calendarYear = calendar.get( Calendar.YEAR );
		int calendarMonth = calendar.get( Calendar.MONTH ) + 1;
		int calendarDay = calendar.get( Calendar.DAY_OF_MONTH );
		int calendarHour = calendar.get( Calendar.HOUR_OF_DAY );
		int calendarMinute = calendar.get( Calendar.MINUTE );
		int calendarSecond = calendar.get( Calendar.SECOND );
		// 引数の値と違いがなければDateを取得。
		if ( (year == calendarYear) &&  ( month == calendarMonth )
				&& ( day == calendarDay ) && ( hour == calendarHour )
				&& ( minute == calendarMinute ) && ( second == calendarSecond ) ) {
			date = calendar.getTime();
		}
		return date;
	}
}
